
nqa<-function(nomifiles,alphakw,alphacor,lwl,clinfile,ctlimit,nominorm)
{
options(digits=6)
options(warn=-1)
import<-function (files)                                                                                                                                           
	{
		c<-list()
		cfinal<-data.frame()
		for ( i in 1:length(files) )
			{
				c[[i]]<-read.table (files[i],header=TRUE,sep="\t",na.strings=c("","."))
				myvars <- c("Well", "Sample","Detector", "Ct","Ct_Avg")
				c[[i]] <- c[[i]][myvars]
				cfinal<-rbind(cfinal,c[[i]])
			}
		return (cfinal)
	}
x<-import(nomifiles)

rep.tec2<-function(ds) 
	{
		finale<-data.frame()
		i<-as.integer(names(table(ds$Sample)))
		for (k in i)
			{
				sub <- ds[ which(ds$Sample==k),]
				sub <- sub[!duplicated(sub$Detector),]
				sub <-sub[order(sub$Sample,sub$Well),]
				finale<-rbind(finale,sub)
			}
		finale$Ct[is.na(finale$Ct)] <- "Undetermined"
		finale$Ct<-replace(finale$Ct,finale$Ct>=ctlimit,"Undetermined")
		finale$Ct_Avg<-replace(finale$Ct_Avg,finale$Ct == "Undetermined","NA")	
		return(finale)
	}

u<-rep.tec2(x)

clin.merge<-function (namefile,ds)
	{
		clin<-read.table(namefile,header=TRUE)
		cat<-paste("Sample_",clin$Sample,sep="")
		clin<-cbind(clin,cat)
		clin<-clin[with(clin, order(cat)), ]
		row.names(clin)<-clin$cat
		Group<-rep(1,length(clin$Sample))
		clin<-cbind(clin,Group)
		keep<-c("Sample","Group")
		clin<-clin[keep]
		Sample<-seq(1,length(clin$Group),by=1)
		clin$Sample<-Sample
		clin<-as.data.frame(clin)
		write.table(clin,file="phenodata_norm2.txt",col.names=TRUE,quote=FALSE,sep="\t")
		final<-read.table(namefile,header=TRUE)		
		final<-merge(final,ds,by.x="Sample",by.y="Sample")
		final<-final[with(final, order(Sample)), ]
		return(final)
		
	}
final<-clin.merge(clinfile,u)
nsamples<-length(table(final$Sample))

		ds.all.detected<-function()
			{
				new<-data.frame()
				y<-final[final$Ct_Avg!="NA",] 
				f<-table(y$Detector,y$y)
				colnames(f)<-c("Controls","Cases")
				print(paste("1. DETECTION"))
				print(paste("Number of samples in which each specific miRNA was detected according to Controls and Cases:"))
				print(f)
				l<-table(y$Detector)
				ll<-l[which(l==length(table(y$Sample)))]
				out<-list("N_Detected"=length(ll),"Detected"=ll)
				print(paste("There are",out$N_Detected,"miRNAs detected in all samples out of",length(l),"evaluated (",round((out$N_Detected/length(l))*100,3),"%)"))
				print(paste("List of miRNAs detected in all samples"))
				miRNA<-names(out$Detected)
				miRNA<-as.data.frame(miRNA)
				Frequency<-unname(out$Detected)
				new<-cbind(miRNA,Frequency)
				print(new)
				miRNA<-as.data.frame(names(out$Detected))
				det<-c()
				for (i in 1:length(out$Detected))
					{
						det[i]<-i
					}
				miRNA<-cbind(miRNA,det)
				names(miRNA)<-c("Detector","det")
				outm<-merge(final,miRNA,by.x="Detector",by.y="Detector")
				outm<-outm[with(outm, order(Sample)), ]
				return(outm)
			}
	outm<-ds.all.detected()


	#Normalization by global mean

	geom<-function(x){exp(mean(log(x)))}
	outm$Ct_Avg<-as.numeric(as.character(outm$Ct_Avg)) 
	q<-aggregate (outm$Ct_Avg,mean,by=list(outm$Sample))
	

	names(q)<-c("Sample","MG_all")
	final1<-merge(outm,q,by.x="Sample",by.y="Sample")
	#Calculation of mdct
	for (i in 1:length(final1$Detector))
			{
				final1$mdct[i]<- -(final1$Ct_Avg[i]-final1$MG_all[i])
			}
	
#Calculation of CVs
	cv.selection<-function ()
		{
			cv<-function(x) 
				{
					cv<-(sd(x)/mean(x))*100
				}
		p<-aggregate (outm$Ct_Avg,cv,by=list(outm$Detector))
		p<-p[with(p, order(x)), ]
		pq<-quantile(p$x,0.20)
		pq<-as.numeric(pq)
		rank<-c()
		for (i in 1:length(p$Group.1))
			{
				rank[i]<-i
			}
		p<-cbind(p,rank)
		names(p)<-c("Detector","CV","Rank")
		p<-subset(p,p$CV<=pq)
		print(paste("2. VARIABILITY"))
		print(paste("There are",length(p$CV),"miRNAs with CV <= 20th centile (",round(pq,4),"%)"))
		print(paste("List of miRNAs with CV <= 20th centile"))
		print(p)		
		return(p)
		}

	p<-cv.selection()
	#Kruskal Wallis test for y of interest
	
	kw.test<-function(ds)
		{
			miRNA<-c()
			ris<-c()
			for (i in 1:length(table(ds$det))) 
				{
					sub <- ds[ which(ds$det==i),]				
					kw<-kruskal.test(sub$mdct ~ sub$y)
					ris[i]<-kw$p.value
					if (ris[i]=="NaN") {
					ris[i]<-1
					}
					miRNA[i]<-as.character(ds$Detector[i])				
				}
			names(ris)<-miRNA
			return(ris)
		}
#Print and dicothomizing of the p-values
	test1<-kw.test(final1)
	test<-subset(test1,test1<=alphakw)
	test<-sort(test)
	test1_dicom<-ifelse(test1<=alphakw,"Sign","Non Sign")
	print(paste("3. INVARIANCE BETWEEN COMPARISON GROUPS"))
	if (length(test)!=0){
	print(paste("List of miRNAs differentially expressed between Cases and Controls by using the overall mean as normalization method"))
	rs<-data.frame()
	miRNA<-names(test)
	miRNA<-as.data.frame(miRNA)
	kw<-unname(test)
	rs<-cbind(miRNA,kw)
	names(rs)<-c("miRNA","K-W p-value")
	print(rs)

	}
	else { print(paste("Message: There aren't any different expressed miRNAs between Cases and Controls"))
	}
	


	

	
#Selection of candidates with the exlusion of reference list
	cand.selection<-function ()
		{
			
			sub<-merge(final1,p,by.x="Detector",by.y="Detector")
			if (length(test)!=0){
			string<-names(test)
			h<-data.frame()
			for (i in 1:length(string))
				{
					for (j in 1:length(sub$Detector))
						{
							if ( string[i] == sub$Detector[j])
								{
									h<-rbind(h,sub[j,])
								} 
						}
				}
			if (nrow(h)!=0){
			o<-table(h$Detector)
			o<-o[which(o==length(table(final1$Sample)))]
			o<-names(o)
			for (k in 1:length(o))
				{
					sub<-subset(sub,sub$Detector!=o[k])
						
				}								
		
		}
		return (sub)
		}	
	else { 
	return(sub)
	}
}
c<-cand.selection()
	

#correlation steps
	rest<-function ()
		{
			finale<-data.frame()
			set<-list()
			freq<-table(c$Detector)
			freq<-freq[which(freq==length(table(final1$Sample)))]
			miRNA<-as.data.frame(names(freq))
			names(miRNA)<-c("Detector")
			detx<-c()
			for (i in 1:length(miRNA$Detector))
				{
					detx[i]<-i
				}
			miRNA<-cbind(miRNA,detx)
			final<-merge(c,miRNA,by.x="Detector",by.y="Detector")
			keep<-c("Sample","Detector","Ct_Avg","detx")
			final<-final[keep]
			lung<-table(final$detx)
			finale<-subset(final,detx==1)
			keepfinale<-c("Sample")
			finale<-finale[keepfinale]
			for (j in 1:length(lung))
				{
					sub <- final[ which(final$detx==j),]
					keepsub<-c("Sample","Ct_Avg")
					sub<-sub[keepsub]
					colnames(sub)[2]<-as.character(miRNA$Detector[j])
					set[[j]]<-merge(sub,finale,by.x="Sample",by.y="Sample")			
				}
			radice<-set[[1]]
			for (k in 2:length(set))
				{
					radice<-merge(radice,set[[k]],by.x="Sample",by.y="Sample")
				}
		return(radice)
		}			
	g<-rest()

	corr<-function (alpha)
		{
			myvars <- names(g) %in% c("Sample") 
			newdata <- g[!myvars]
			out<-list()
			k<-1
			lista<-list()
			for ( i in 1:length(newdata))
				{
					for (j in 1:length(newdata))
						{
							miRNAf<-c(names(newdata[i]))
							miRNAl<-c(names(newdata[j]))
							if (miRNAf == miRNAl){break}
							st.sp<-cor(newdata[i],newdata[j],method="spearman")
							st.se<-cor(newdata[i],newdata[j])
							a<-atanh(st.sp)
							b<-qnorm(1-alpha/2)*sqrt(1/(nsamples-3))
							lcl<-a-b
							ucl<-a+b
							lcltrasf<-tanh(lcl)
							ucltrasf<-tanh(ucl)
							copy<-mapply(cbind,miRNAf,miRNAl,st.sp,lcltrasf,ucltrasf)
							lista[[k]]<-list(copy)
							out[[k]]<-list("miRNA1"=miRNAf,"miRNA2"=miRNAl,"Spearman"=st.sp,"LCL"=lcltrasf,"UCL"=ucltrasf)
							k<-k+1
						}
				}
		return(out)
		}
	f<-corr(alphacor)

	exlcorr<-function()
		{
			black<-list()
			j<-1
			for (i in 1:length(f))
				{
					if (abs(f[[i]]$LCL) >= lwl)
						{
							black[[j]]<-c(f[[i]]$miRNA1,f[[i]]$miRNA2)
							j<-j+1
						}
				}
		
		return(black)

		}

	retcor<-function()
		{
			black<-list()
			j<-1
			for (i in 1:length(f))
				{
					if (abs(f[[i]]$LCL) >= lwl)
						{
							black[[j]]<-c(f[[i]]$Spearman,f[[i]]$LCL,f[[i]]$UCL)
							j<-j+1
						}
				}
		
		return(black)

		}


	tips<-exlcorr()
	cor<-retcor()
	print(paste("4. CO-REGULATION"))
	if (length(tips)!=0){
	print(paste("Pairs of miRNAs higly correlated with their Spearman Correlation Coefficient and 95% Fisher Confidence Interval:"))
	for (i in 1:length(tips))
	{
		print(tips[[i]])
		print(paste("Correlation:",round(cor[[i]][[1]],4),"95%CI[",round(cor[[i]][[2]],4),",",round(cor[[i]][[3]],4),"]"))
	}
	sel<-function()
		{
			l<-1
			rank<-c()
			cont<-list()
			miRNA<-c()
			for (j in 1:length(tips))
				{
					for (k in 1:2) 
						{
							for (i in 1:length(p$Detector))
								{
									d<-as.vector(tips[[j]][k])
									if (as.character(p$Detector[i])==d)
										{
											miRNA<-c(miRNA,d)
											rank<-c(rank,p$Rank[i])
											names(rank)<-miRNA
										}
								}
					
						}
				cont[[l]]<-rank
				l<-l+1
				rank<-c()
				miRNA<-c()
				}
				
		return(cont)
		}
	prova<-sel()

	list.ref<-function ()
		{
			print(paste("List of miRNAs excluded within each pair"))
			mdel<-c()
			for (i in 1:length(prova)) 
				{
					if (prova[[i]][1] > prova[[i]][2])
						{
							mdel<-c(mdel,names(prova[[i]][1]))
							
							

						}
					else  
						{ 
							mdel<-c(mdel,names(prova[[i]][2]))
						}
					
				}
					
					for (j in 1:length(mdel))
						{
							if (j==1)
								{
									dsref<-subset(c,c$Detector!=mdel[j])
								}
							else {
									dsref<-subset(dsref,dsref$Detector!=mdel[j])
								}
				}
		mdel<-unique(mdel)		
		print(paste(mdel))
		return(dsref)
		}
w<-list.ref()
}
else { 
print("Message: There aren't co-regulated miRNAs")
w<-c }

	txt<-function()
		{
			nam<-c()
			w<-w[order(w$Detector, w$Sample),]
			id<-as.integer(names(table(w$Sample)))
			for ( i in id)
				{
					nam <- c(nam,paste("Sample",i, sep="_"))
				}
			o<-table(w$Detector)
			o<-o[which(o==length(table(final$Sample)))]
			o<-length(o)
			sample_c<-rep(nam,o)
			w<-cbind(w,sample_c)
			keepfinale<-c("sample_c","Detector","Ct_Avg")
			w<-w[keepfinale]
			names(w)<-c("Sample","Detector","Cq")
		return(w)			
		}
	ref_list<-txt()


	write.table(ref_list,file="list_ref.txt",col.names=TRUE,row.names=FALSE)

#norm function
	norm<-function ()
		{
			print(paste("5. STABILITY"))
			y <- read.AnnotatedDataFrame("phenodata_norm2.txt",header=T)
			pData(y)
			z <- read.qPCR("list_ref.txt",phenoData=y) 
			exprs(z) 
			pData(z)
			ge <- selectHKs(z, method = "geNorm",Symbols = featureNames (z) , minNrHK = 2, log = TRUE,trace=FALSE)
			r<-stabMeasureRho(z, group="Group", log = TRUE, na.rm = TRUE,returnAll=FALSE)
			c<-as.integer(names(ge$ranking))
			names(c)<-ge$ranking
			normrank<-c()
			for (i in 1:length(r))
				{
					r<-sort(r)
					normrank[i]<-i
				}
			names(normrank)<-names(r)
			rank<-c()
			names_normf<-as.vector(names(normrank))
			names_ge<-as.vector(names(c))
			for (i in 1:length(names_ge))
				{
					for (j in 1: length (names_normf))
						{
							if (names_ge[i] == names_normf[j])
								{
									rank[i]=c[i]+normrank[j]
									names(rank[i])<-names_ge[i]
								}
						}						
				}

			names(rank)<-names_ge
			rank<-sort(rank)
	return(rank)
	}
	l<-norm()
	print(paste("Rank of the candidate reference miRNAs by jointly considering geNorm and NormFinder softwares:"))
	names(l)<-gsub(".","-",names(l),fixed=TRUE)
	rs<-data.frame()
	Candidate_Reference<-names(l)
	miRNA<-as.data.frame(miRNA)
	Rank<-unname(l)
	rs<-cbind(Candidate_Reference,Rank)
	print(rs)
	#ricorsively kappa
	if (length(test)!=0){
	decisiva<-function ()
		{
			print(paste("6. AGREEMENT"))
			cand<-data.frame()
			norm<-c()
			mg_geom<-data.frame()
			my<-list()
			ds<-list()
			mdct<-c()
			stata<-list()
			statao<-list()
			dicom_stat<-list()
			dicom<-list()
			Detector<-names(l)
			n<-list()
			k<-list()
			kappa<-c()
			lclkappa<-c()
			uclkappa<-c()
			Detector<-gsub(".","-",Detector,fixed=TRUE)
			cand<-cbind(Detector)
			for (j in 1:length(Detector))
				{
					norm<-c(norm,cand[j])
					normx<-as.data.frame(norm)
					names(normx)<-c("Detector")
					my[[j]]<-merge(normx,final1,by.x="Detector",by.y="Detector")
					mg_geom<-aggregate(my[[j]]$Ct_Avg,mean,by=list(my[[j]]$Sample))
					names(mg_geom)<-c("Sample","MG")
					my[[j]]<-merge(mg_geom,final1,by.x="Sample",by.y="Sample")
					myvars <- names(my[[j]]) %in% c("mdct") 
					my[[j]] <- my[[j]][!myvars]
				for (i in 1:length(my[[j]]$Sample))
					{
						mdct[i]<--(my[[j]]$Ct_Avg[i]-my[[j]]$MG[i])
					}
					my[[j]]<-cbind(my[[j]],mdct)	
					stata[[j]]<-kw.test(my[[j]])
					statao[[j]]<-sort(stata[[j]])
					dicom_stat<-ifelse (statao[[j]]<=alphakw,"Sign","Non Sign")				
					dicom[[j]]<-dicom_stat
					n[[j]]<-dicom[[j]]
					Detector1<-names(n[[j]])
					n[[j]]<-cbind(n[[j]],Detector1)
					nn<-test1_dicom
					Detectorn<-names(nn)
					nn<-cbind(nn,Detectorn)
					ntot<-merge(n[[j]],nn,by.x="Detector1",by.y="Detectorn")
					t<-table(ntot)
					myvars <- c("V1", "nn")
					ntot <- ntot[myvars]
					t<-table(ntot)
					k[[j]]<-epi.kappa(t,method="fleiss",conf.level=0.95)
					kappa<-c(kappa,k[[j]]$kappa$est)
					lclkappa<-c(lclkappa,k[[j]]$kappa$lower)
					uclkappa<-c(uclkappa,k[[j]]$kappa$upper)			
				}
		kappa<-replace(kappa,kappa>1,1)
		lclkappa<-replace(lclkappa,lclkappa>1,1)
		uclkappa<-replace(uclkappa,uclkappa>1,1)
		lclkappa<-replace(lclkappa,lclkappa=="NaN",-1)
		uclkappa<-replace(uclkappa,uclkappa=="NaN",-1)
		kappa<-kappa[-1]
		lclkappa<-lclkappa[-1]
		uclkappa<-uclkappa[-1]
		maxucl<-max(uclkappa)
		if (maxucl<0.800)
			{
				posmaxk<-which.max(kappa)
				posnorm<-which.max(kappa)+1
				maxk<-kappa[posmaxk]
				normalizers<-norm[c(1:posnorm)]
				normalizersdf<-as.data.frame(normalizers)
			}
		else
			{
				for (k in 1:length(uclkappa))
					{
						if (uclkappa[k]>=0.800)
							{
								posmaxk<-k
								posnorm<-k+1
								maxk<-kappa[posmaxk]
								normalizers<-norm[c(1:posnorm)]
								normalizersdf<-as.data.frame(normalizers)
								break
							}
						
					}
			}
					
		dsnorm<-my[[posnorm]]
		signnorm<-stata[[posnorm]]
		out<-list("Normalizers"=normalizers,"N_subset"=posnorm,"kappa"=kappa,"LCL"=lclkappa,"UCL"=uclkappa,"ds_norm"=dsnorm,"ds_overall"=final1,"sign_norm"=signnorm,"sign_overall"=test1,"sign_level"=alphakw)
		print(paste("Kappa Statistic:",round(maxk,4),"95%CI[",round(lclkappa[posmaxk],4),",",round(uclkappa[posmaxk],4),"] corresponding to the best set of reference miRNAs"))
		print(paste("Best set of reference miRNAs:"))
		names(normalizersdf)<-c("Reference miRNAs")
		print(normalizersdf)
		print(paste("The number of miRNAs belonging to the best set is:",posnorm))
	return(out)				
	}
	b<-decisiva()
	serie<-c()
	serie<-seq(2,(length(b$kappa)+1),by=1)
	dev.new()
	plotCI(serie, b$kappa, ui=b$UCL, li=b$LCL,ylim=c(0,1),xlab="Number of candidate reference miRNAs",ylab="Kappa Statistic and its 95% Confidence Interval",pch=20,cex=1,xaxt="n",yaxt="n")
	arrows(b$N_subset,0.10,b$N_subset,0,col="Black",length=0.10,lwd=2)
	abline(h=0.80,add=T,lty=2)
	axis(1,2:(length(b$kappa)+1),by=1)
	axis(2,seq(0,1,by=0.2))
	title("Kappa Statistic values")
	

}
else {print(paste("Error:The procedure cannot be execute because there aren't miRNAs diffent expressed in the reference List"))}


volcano<-function(ds,var,alphakw)
{
	dev.new()
	dsx<-ds
	varx<-var
	s<-alphakw	
	risultati<-data.frame()
	ds<-data.frame()
	dscases<-dsx[ which(dsx$y==1),]
	dscontrol<-dsx[ which(dsx$y==0),]
	z<-aggregate (dscases$mdct,median,by=list(dscases$Detector))
	names(z)<-c("Detector","Cases")
	e<-aggregate (dscontrol$mdct,median,by=list(dscontrol$Detector))
	names(e)<-c("Detector","Controls")
	risultati<-merge(z,e,by.x="Detector",by.y="Detector")
	FC<-risultati$Cases-risultati$Controls
	risultati<-cbind(risultati,FC)
	miRNA<-names(varx)
	names(varx)<-NULL
	test<--log10(varx)
	risultati<-cbind(risultati,test)
	output<-risultati
	output<-cbind(output,varx)
	output<-output[with(output, order(varx)), ]
	names(output)<-c("miRNA","Median(Cases)","Median(Controls)","Fold Change","-log10(KW p-value)","KW p-value")
	print(paste("7. SUMMARY OF THE RESULTS:"))
	print(output)
	cut<--log10(s)
	minmaxFC<-c()
	maxFC<-max(risultati$FC)
	minFC<-min(risultati$FC)
	minmaxFC<-c(minFC,maxFC)
	ax<-abs(max(minmaxFC))
	plot(risultati$FC,risultati$test,xlim=c(-ax-1.75,ax+1.75),xlab="Fold Change",ylab="-log10(KW p-value)")
	risultatired<-risultati[risultati$test>cut,]
	textxy(risultatired$FC,risultatired$test,risultatired$Detector,cex=0.7,offset=0.6,col="black")
	points(risultatired$FC,risultatired$test,col="black",add=T,pch=20,cex=1.5)
	title("Volcano Plot")
	abline(h=cut,lty=2);text(-ax-1.5,cut-0.05,substitute(paste("",alpha,"=",s)))
}
volcano(b$ds_norm,b$sign_norm,alphakw)

given_norm<-function(ds,norm,alphakw)
{
kw.test<-function(ds)
		{
			miRNA<-c()
			ris<-c()
			for (i in 1:length(table(ds$det))) 
				{
					sub <- ds[ which(ds$det==i),]				
					kw<-kruskal.test(sub$mdct ~ sub$y)
					ris[i]<-kw$p.value
					if (ris[i]=="NaN") {
					ris[i]<-1
					}
					miRNA[i]<-as.character(sub$Detector[1])				
				}
			names(ris)<-miRNA
			return(ris)
		}
	test1<-kw.test(ds)
	test<-subset(test1,test1<=alphakw)
	test<-sort(test)
	test1_dicom<-ifelse(test1<=alphakw,"Sign","Non Sign")
					geom<-function(x){exp(mean(log(x)))}
					my<-list()
					mdct<-c()
					stata<-list()
					statao<-list()
					dicom_stat<-list()
					dicom<-list()
					Detector<-names(norm)
					n<-list()
					k<-list()
					kappa<-c()
					lclkappa<-c()
					uclkappa<-c()
					j<-1
					normx<-as.data.frame(norm)
					names(normx)<-c("Detector")
					my[[j]]<-merge(normx,ds,by.x="Detector",by.y="Detector")
					mg_geom<-aggregate(my[[j]]$Ct_Avg,mean,by=list(my[[j]]$Sample))
					names(mg_geom)<-c("Sample","MG")
					my[[j]]<-merge(mg_geom,ds,by.x="Sample",by.y="Sample")
					myvars <- names(my[[j]]) %in% c("mdct") 
					my[[j]] <- my[[j]][!myvars]
				for (i in 1:length(my[[j]]$Sample))
					{
						mdct[i]<--(my[[j]]$Ct_Avg[i]-my[[j]]$MG[i])
					}
					my[[j]]<-cbind(my[[j]],mdct)	
					stata[[j]]<-kw.test(my[[j]])
					statao[[j]]<-sort(stata[[j]])
					dicom_stat<-ifelse (statao[[j]]<=alphakw,"Sign","Non Sign")				
					dicom[[j]]<-dicom_stat
					n[[j]]<-dicom[[j]]
					Detector1<-names(n[[j]])
					n[[j]]<-cbind(n[[j]],Detector1)
					nn<-test1_dicom
					Detectorn<-names(nn)
					nn<-cbind(nn,Detectorn)
					ntot<-merge(n[[j]],nn,by.x="Detector1",by.y="Detectorn")
					t<-table(ntot)
					myvars <- c("V1", "nn")
					ntot <- ntot[myvars]
					t<-table(ntot)
					k[[j]]<-epi.kappa(t,method="fleiss",conf.level=0.95)
					kappa<-c(kappa,k[[j]]$kappa$est)
					lclkappa<-c(lclkappa,k[[j]]$kappa$lower)
					uclkappa<-c(uclkappa,k[[j]]$kappa$upper)
					kappa<-replace(kappa,kappa>1,1)
					lclkappa<-replace(lclkappa,lclkappa>1,1)
					uclkappa<-replace(uclkappa,uclkappa>1,1)	
					normalizers<-norm
					normalizersdf<-as.data.frame(normalizers)
					dsnorm<-my[[j]]
					signnorm<-stata[[j]]
					out<-list("Normalizers"=normalizers,"N_subset"=length(norm),"kappa"=kappa,"LCL"=lclkappa,"UCL"=uclkappa,"ds_norm"=dsnorm,"sign_norm"=signnorm,"sign_level"=alphakw)
					return(out)
}
number<-c()
sc<-0
for (i in 1:length(nominorm)){
x<-subset(b$ds_overall,b$ds_overall$Detector==nominorm[i])
number[i]<-length(table(x$Sample))
names(number[i])<-nominorm[i]
if (number[i] != nsamples){
sc<-1
print(paste("Message: miRNA(s) chosen for normalization aren't detected in all samples (i.e.",nominorm[i],"). Please check '1.DETECTION' output section."))
break
}
else {sc<-0}
}


if (!is.null(nominorm)){
if (sc==0)
{
s<-given_norm(b$ds_overall,nominorm,alphakw)
efficacy<-function(ds_overall,ds_norm,ds_choose)
{
	max1<-max(ds_overall$mdct)
	min1<-min(ds_overall$mdct)	
	max2<-max(ds_norm$mdct)
	min2<-min(ds_norm$mdct)
	max3<-max(ds_choose$mdct)
	min3<-min(ds_choose$mdct)
	max<-max(max1,max2,max3)
	min<-min(min1,min2,min3)
	if (abs(max)>=abs(min)) {
	axe<-max
	}
	else
	{
	axe<-min
	}
	dev.new()
	par(mfrow=c(2,3))
	
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("Overall Mean",cex.main=2)
	x<-subset(ds_overall,ds_overall$y==1)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	
	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("NqA",cex.main=2)
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)


	boxplot(ds_choose$mdct~ds_choose$Sample,subset=ds_choose$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray100")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("User choice",cex.main=2)
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

      
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	x<-subset(ds_overall,ds_overall$y==0)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)
	
	boxplot(ds_choose$mdct~ds_choose$Sample,subset=ds_choose$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray100")), ylab="log2(RQ)Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)
	close.screen( all = TRUE )

}
efficacy(b$ds_overall,b$ds_norm,s$ds_norm)
}
else{
efficacy<-function(ds_overall,ds_norm)
{
	dev.new()
	par(mfrow=c(2,2))
	max1<-max(ds_overall$mdct)
	min1<-min(ds_overall$mdct)	
	max2<-max(ds_norm$mdct)
	min2<-min(ds_norm$mdct)
	max<-max(max1,max2)
	min<-min(min1,min2)
	if (abs(max)>=abs(min)) {
	axe<-max
	}
	else
	{
	axe<-min
	}

	
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("Overall Mean Strategy",cex.main=2)
	x<-subset(ds_overall,ds_overall$y==1)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("NqA",cex.main=2)
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)


      
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5), xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	x<-subset(ds_overall,ds_overall$y==0)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)
	
	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	close.screen( all = TRUE )

}
efficacy(b$ds_overall,b$ds_norm)
}
}
else{
efficacy<-function(ds_overall,ds_norm)
{
	dev.new()
	par(mfrow=c(2,2))
	max1<-max(ds_overall$mdct)
	min1<-min(ds_overall$mdct)	
	max2<-max(ds_norm$mdct)
	min2<-min(ds_norm$mdct)
	max<-max(max1,max2)
	min<-min(min1,min2)
	if (abs(max)>=abs(min)) {
	axe<-max
	}
	else
	{
	axe<-min
	}

	
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("Overall Mean Strategy",cex.main=2)
	x<-subset(ds_overall,ds_overall$y==1)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==1,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Cases",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	title("NqA",cex.main=2)
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)


      
	boxplot(ds_overall$mdct~ds_overall$Sample,subset=ds_overall$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5), xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray60")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	x<-subset(ds_overall,ds_overall$y==0)
	sample<-as.character(unique(x$Sample))
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)
	
	
	boxplot(ds_norm$mdct~ds_norm$Sample,subset=ds_norm$y==0,ylim=c(-abs(axe)+0.5,abs(axe)+0.5),xaxt="n",
	pars=list(boxwex=0.5,staplewex=0.3,outwex=0.3, whisklty=1, medlwd=1,medcolor="black"),
	col=(c("gray80")), ylab="log2(RQ) Controls",cex.lab=1,xlab="Samples",outline=FALSE)
	box(lty = 1, col = 'white',bty="7")
	axis(1,at=1:(length(table(x$Sample))),labels=sample,tick=TRUE,cex.axis=0.8)

	close.screen( all = TRUE )

}
efficacy(b$ds_overall,b$ds_norm)
}

return(b)
}






